--[[-------------------------------------------------------------------------
This NWC user tool can be used to find all chord names in a staff that have
been added with Insert, Text and convertr them into ChordPlay.lp objects.

$NWCUT$CONFIG: ClipText $
--]]-------------------------------------------------------------------------

-- we want to work with basic text for most lines
nwcut.setlevel(1)

local changeCount = 0

local function getNoteBaseAndChordList(fullname)
	if not fullname then return end
	local n,c,inv = fullname:match('^%s*([A-G][b#]?)([^/%s]*)%s*/*%s*([^%s]*)%s*$')
	if not n then return end
	if not notenameShift[n] then return end
	local k = chordKeys[c]

	if (inv == '') then
		inv = nil
	elseif not inv:match('^[A-G][b#]?%s*$') then
		return
	end
	
	if k then return n,c,k,inv end
end

for item in nwcut.items() do
	if item:Is('Text') then
		local textProp = item:Get('Text') or '--'
		if textProp:match('^%"*%s*[A-G][b#]?[^/%s]*%s*/*%s*[^%s]*%s*%"*$') then
			local newItem = nwcItem.new('|User|ChordPlay.lp')
			-- local newPos = (tonumber(item:Get('Pos')) or 0) - 1
			local newPos = (tonumber(item:Get('Pos')) or 0) - 5
			newItem:Provide('Name',textProp)
			newItem:Provide('Pos',newPos)

			item = newItem
			changeCount = changeCount + 1
		end
	end

	nwcut.writeline(item)
end

if changeCount < 1 then
	nwcut.warn('No named chords found')
else
	nwcut.warn('Change '..changeCount..' object'..((changeCount == 1) and '' or 's'))
end
